
#ifndef _REPLACE_HPP_
#define _REPLACE_HPP_


# define false 0
# define true  1

# define MAXSTR 100
# define MAXPAT MAXSTR

# define ENDSTR  '\0'
# define ESCAPE  '@'
# define CLOSURE '*'
# define BOL     '%'
# define EOL     '$'
# define ANY     '?'
# define CCL     '['
# define CCLEND  ']'
# define NEGATE  '^'
# define NCCL    '!'
# define LITCHAR 'c'
# define DITTO   -1
# define DASH    '-'

# define TAB     9
# define NEWLINE 10

# define CLOSIZE 1


namespace ta1_uebung05 {


    typedef char character;
    typedef char string[MAXSTR];

    bool getline(char *s, int maxsize);
    int addstr(char c, char *outset, int *j, int maxset);
    char esc(char *s, int *i);
    void dodash(char delim, char *src, int *i, char *dest, int *j, int maxset);
    bool getccl(char *arg, int *i, char *pat, int *j);
    void stclose(char *pat, int *j, int lastj);
    bool in_set_2(char c);
    bool in_pat_set(char c);
    int makepat(char *arg, int start, char delim, char *pat);
    int getpat(char* arg, char* pat);
    int makesub(char *arg, int from, char delim, char *sub);
    bool getsub(char* arg, char* sub);
    bool locate(char c, char *pat, int offset);
    bool omatch(char *lin, int *i, char *pat, int j);
    int patsize(char *pat, int n);
    int amatch(char *lin, int offset, char *pat, int j);
    void putsub(char *lin, int s1, int s2, char *sub, char *resStr);
    void subline(char *lin, char *pat, char	*sub, char *resStr);
    void Caseerror(int n);


}; // namespace ta1_uebung05


#endif // _REPLACE_HPP_
